config/urls.py
from django.conf import settings
from django.conf.urls import url, include

from django.contrib import admin
from django.contrib.auth.views import logout
from django.views.generic import TemplateView

# Import feeds
import core.views
from events.feeds import EventFeed, feedview
import events.reports
import events.views
from ligoauth.views import pre_login, post_login, shib_logout, manage_password
import search.views

# Django admin auto-discover
admin.autodiscover()

feeds = {
    'latest' : EventFeed
}


urlpatterns = [
    url(r'^$', events.views.index, name="home"),
    url(r'^navbar_only$', TemplateView.as_view(
        template_name='navbar_only.html'), name="navbar-only"),
    url(r'^SPInfo', TemplateView.as_view(template_name='gracedb/spinfo.html'),
         name="spinfo"),
    url(r'^SPPrivacy', TemplateView.as_view(
        template_name='gracedb/spprivacy.html'), name="spprivacy"),
    url(r'^DiscoveryService', TemplateView.as_view(
        template_name='discovery.html'), name="discovery"),
    url(r'^events/', include('events.urls')),
    url(r'^superevents/', include('superevents.urls')),
    url(r'^alerts/', include('alerts.urls')),
    url(r'^feeds/(?P<url>.*)/$', EventFeed()),
    url(r'^feeds/$', feedview, name="feeds"),

    url(r'^other/$', TemplateView.as_view(template_name='other.html'),
        name='other'),
    url(r'^performance/$', events.views.performance, name="performance"),
    url(r'^reports/$', events.reports.histo, name="reports"),
    url(r'^reports/cbc_report/(?P<format>(json|flex))?$',
        events.reports.cbc_report, name="cbc_report"),
    url(r'^latest/$', search.views.latest, name="latest"),
    #(r'^reports/(?P<path>.+)$', 'django.views.static.serve',
    #        {'document_root': settings.LATENCY_REPORT_DEST_DIR}),
    url(r'^search/$', search.views.search, name="mainsearch"),

    # Authentication
    url(r'^login/$', pre_login, name='login'),
    url(r'^post-login/$', post_login, name='post-login'),
    url(r'^logout/$', shib_logout, name='logout'),

    # Password management
    url('^manage-password/$', manage_password, name='manage-password'),

    # API URLs
    url(r'^api/', include('api.urls')),
    # Legacy API URLs - must be maintained!
    url(r'^apibasic/', include('api.urls', namespace='legacy_apibasic')),
    url(r'^apiweb/', include('api.urls', namespace='legacy_apiweb')),

    # Heartbeat URL
    url(r'^heartbeat/$', core.views.heartbeat, name='heartbeat'),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', admin.site.urls),

    # Sessions
    url(r'^', include('user_sessions.urls', 'user_sessions')),

]

# We don't require settings.DEBUG for django-silk since running unit tests
# by default setings settings.DEBUG to False, unless you use the
# --debug-mode flag
if ('silk' in settings.INSTALLED_APPS):
    # Add django-silk
    urlpatterns = [
        url(r'^silk/', include('silk.urls', namespace='silk'))
    ] + urlpatterns

# Add django-debug-toolbar
if settings.DEBUG and 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

gracedb/alerts/urls.py
from django.conf.urls import url

from . import views

app_name = 'alerts'


urlpatterns = [
    # Base /options/ URL
    url(r'^$', views.index, name="index"),

    # Contacts
    url(r'^contact/create/', views.CreateContactView.as_view(),
        name='create-contact'),
    url(r'^contact/(?P<pk>\d+)/edit/$', views.EditContactView.as_view(),
        name="edit-contact"),
    url(r'^contact/(?P<pk>\d+)/delete/$', views.DeleteContactView.as_view(),
        name="delete-contact"),
    url(r'^contact/(?P<pk>\d+)/test/$', views.TestContactView.as_view(),
        name="test-contact"),
    url(r'^contact/(?P<pk>\d+)/request-code/$',
        views.RequestVerificationCodeView.as_view(),
        name="request-verification-code"),
    url(r'^contact/(?P<pk>\d+)/verify/$', views.VerifyContactView.as_view(),
        name="verify-contact"),

    # Notifications
    url(r'^notification/create/$', views.CreateNotificationView.as_view(),
        name="create-notification"),
    url(r'^notification/(?P<pk>\d+)/edit/$',
        views.EditNotificationView.as_view(), name="edit-notification"),
    url(r'^notification/(?P<pk>\d+)/delete/$',
        views.DeleteNotificationView.as_view(), name="delete-notification"),
]

gracedb/api/urls.py
from django.conf.urls import url, include

from .v1 import urls as v1_urls
from .v2 import urls as v2_urls

app_name = 'api'


urlpatterns = [
    url(r'^', include((v1_urls, 'default'))),
    url(r'^v1/', include((v1_urls, 'v1'))),
    url(r'^v2/', include((v2_urls, 'v2'))),
]

gracedb/core/urls.py
# URL utilities

from django.contrib.sites.models import Site


def build_absolute_uri(relative_uri, request=None):
    if request is not None:
        return request.build_absolute_uri(relative_uri)
    else:
        # Assume HTTPS
        domain = Site.objects.get_current().domain
        return 'https://' + domain + relative_uri

gracedb/superevents/urls.py
from django.conf.urls import url, include
from .models import Superevent
from . import views

app_name = 'superevents'


# URLs which are nested below a superevent detail
# These are included under a superevent's ID URL prefix (see below)
suburlpatterns = [

    # Superevent detail view
    url(r'^view/$', views.SupereventDetailView.as_view(), name="view"),

    # File list (file detail/download is handled through the API)
    url(r'^files/$', views.SupereventFileList.as_view(), name="file-list"),
]

# Legacy URL patterns - don't really need them, but we use them for the
# convenience of users who may be accustomed to the legacy event URL patterns
legacy_urlpatterns = [
    # Legacy URLs for superevent detail view
    url(r'^(?P<superevent_id>{regex})/$'.format(
        regex=Superevent.ID_REGEX), views.SupereventDetailView.as_view(),
        name="legacyview1"),
    url(r'^view/(?P<superevent_id>{regex})/$'.format(
        regex=Superevent.ID_REGEX), views.SupereventDetailView.as_view(),
        name="legacyview2"),
]

# Full urlpatterns: legacy urls plus suburlpatterns nested under
# superevent_id
urlpatterns = legacy_urlpatterns + [
    url(r'^(?P<superevent_id>{regex})/'.format(regex=Superevent.ID_REGEX),
        include(suburlpatterns)),

    # View of all candidates
    url(r'^public/O3/$', views.SupereventPublic.as_view(),
        name="public-alerts-O3"),
]

gracedb/alerts/models.py
from collections import defaultdict
import logging
import random
import textwrap

from django.conf import settings
from django.contrib.auth import get_user_model
from django.core.exceptions import ValidationError, NON_FIELD_ERRORS
from django.core.mail import EmailMessage
from django.db import models
from django.utils import timezone
from django.utils.http import urlencode

from django_twilio.client import twilio_client

from core.models import CleanSaveModel
from .fields import PhoneNumberField
from .phone import get_twilio_from


# Set up logger
logger = logging.getLogger(__name__)

# Set up user model
UserModel = get_user_model()

###############################################################################
# Contacts ####################################################################
###############################################################################
class Contact(CleanSaveModel):
    # Phone contact methods
    CONTACT_PHONE_CALL = 'C'
    CONTACT_PHONE_TEXT = 'T'
    CONTACT_PHONE_BOTH = 'B'
    CONTACT_PHONE_METHODS = (
        (CONTACT_PHONE_CALL, 'Call'),
        (CONTACT_PHONE_TEXT, 'Text'),
        (CONTACT_PHONE_BOTH, 'Call and text'),
    )
    # Number of digits in verification codes
    CODE_DIGITS = 6

    # Fields
    user = models.ForeignKey(UserModel, null=False)
    description = models.CharField(max_length=30, blank=False, null=False)
    email = models.EmailField(blank=True, null=True)
    phone = PhoneNumberField(blank=True, max_length=255, null=True)
    phone_method = models.CharField(max_length=1, null=True, blank=True,
        choices=CONTACT_PHONE_METHODS, default=None)
    verified = models.BooleanField(default=False, editable=False)
    verification_code = models.IntegerField(null=True, editable=False)
    verification_expiration = models.DateTimeField(null=True, editable=False)
    # Fields for tracking when certain things happen
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    verified_time = models.DateTimeField(null=True, blank=True, editable=False)


    def __str__(self):
        return "{0}: {1}".format(self.user.username, self.description)

    def clean(self):
        # Mostly used for preventing creation of bad Contact
        # objects through the Django interface.
        super(Contact, self).clean()

        err_dict = defaultdict(list)
        # If a phone number is given, require either call or text to be True.
        if (self.phone is not None and self.phone_method is None):
            err_msg = 'Choose a phone contact method.'
            err_dict['phone_method'].append(err_msg)

        if (self.phone is None and self.phone_method is not None):
            err_msg = '"Call" and "text" should be False for non-phone alerts.'
            err_dict['phone'].append(err_msg)

        # Only one contact method is allowed
        if (self.email is not None and self.phone is not None):
            err_msg = \
                'Only one contact method (email or phone) can be selected.'
            err_dict[NON_FIELD_ERRORS].append(err_msg)

        # If no e-mail or phone given, raise error.
        # We have to skip this due to really annoying behavior with forms.. :(
        #if not (self.email or self.phone):
        #    err_msg = \
        #        'One contact method (email or phone) is required.'
        #    err_dict[NON_FIELD_ERRORS].append(err_msg)

        if err_dict:
            raise ValidationError(err_dict)

    def generate_verification_code(self):
        self.verification_code = random.randint(10**(self.CODE_DIGITS-1),
            (10**self.CODE_DIGITS)-1)
        self.verification_expiration = timezone.now() + \
            settings.VERIFICATION_CODE_LIFETIME
        self.save(update_fields=['verification_code',
            'verification_expiration'])

    def send_verification_code(self):
        # Message for texts and emails
        msg = ('Verification code for contact "{desc}" on {host}: {code}. '
            'If you did not request a verification code or do not know what '
            'this is, please disregard.').format(desc=self.description,
            host=settings.LIGO_FQDN, code=self.verification_code)

        if self.email:
            subject = 'Verification code for contact "{desc}" on {host}' \
                .format(desc=self.description, host=settings.LIGO_FQDN)
            email = EmailMessage(subject, msg,
                from_email=settings.ALERT_EMAIL_FROM, to=[self.email])
            email.send()
        elif self.phone:
            from_ = get_twilio_from()

            if (self.phone_method == self.CONTACT_PHONE_CALL):
                # If phone method is only call, send a call

                # Convert code to a string with spaces between the numbers
                # so it's pronounced properly by text-to-voice
                code = " ".join(str(self.verification_code))
                urlparams = urlencode({'code': code})
                twiml_url = '{base}{twiml_bin}?{params}'.format(
                    base=settings.TWIML_BASE_URL,
                    twiml_bin=settings.TWIML_BIN['verify'],
                    params=urlparams)
                twilio_client.calls.create(to=self.phone, from_=from_,
                    url=twiml_url, method='GET')
            else:
                # If method is text or both, send a text
                twilio_client.messages.create(to=self.phone, from_=from_,
                    body=msg)

    def verify(self):
        if not self.verified:
            self.verified = True
            self.verified_time = timezone.now()
            self.save(update_fields=['verified', 'verified_time'])

    def display(self):
        if self.email:
            return "Email {0}".format(self.email)
        elif self.phone:
            if self.phone_method == self.CONTACT_PHONE_BOTH:
                return "Call and text {0}".format(self.phone)
            elif self.phone_method == self.CONTACT_PHONE_CALL:
                return "Call {0}".format(self.phone)
            if self.phone_method == self.CONTACT_PHONE_TEXT:
                return "Text {0}".format(self.phone)

    def print_info(self):
        """Prints information about Contact object; useful for debugging."""
        info_str = textwrap.dedent("""\
            Contact "{description}" (user {username})
            E-mail: {email}
            Phone: {phone} (method={method})
            Created: {created_time}
            Last updated: {updated_time}
            Verified: {verified} ({verified_time})
        """).format(description=self.description, username=self.user.username,
        email=self.email, phone=self.phone, method=self.phone_method,
        created_time=self.created, updated_time=self.updated,
        verified=self.verified, verified_time=self.verified_time)
        print(info_str)


###############################################################################
# Notifications ###############################################################
###############################################################################
class Notification(models.Model):
    # Notification categories
    NOTIFICATION_CATEGORY_EVENT = 'E'
    NOTIFICATION_CATEGORY_SUPEREVENT = 'S'
    NOTIFICATION_CATEGORY_CHOICES = (
        (NOTIFICATION_CATEGORY_EVENT, 'Event'),
        (NOTIFICATION_CATEGORY_SUPEREVENT, 'Superevent'),
    )
    user = models.ForeignKey(UserModel, null=False)
    contacts = models.ManyToManyField(Contact)
    description = models.CharField(max_length=40, blank=False, null=False)
    far_threshold = models.FloatField(blank=True, null=True)
    labels = models.ManyToManyField('events.label', blank=True)
    label_query = models.CharField(max_length=100, null=True, blank=True)
    category = models.CharField(max_length=1, null=False, blank=False,
        choices=NOTIFICATION_CATEGORY_CHOICES,
        default=NOTIFICATION_CATEGORY_SUPEREVENT)
    # Fields for tracking when certain things happen
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    # Whether the event possibly has a neutron star in it.
    # The logic for determining this is defined in a method below.
    ns_candidate = models.BooleanField(default=False)
    # Event-only fields
    groups = models.ManyToManyField('events.group', blank=True)
    pipelines = models.ManyToManyField('events.pipeline', blank=True)
    searches = models.ManyToManyField('events.search', blank=True)

    def __unicode__(self):
        return (u"%s: %s") % (
            self.user.username,
            self.display()
        )

    def display(self):
        kwargs = {}
        if self.category == self.NOTIFICATION_CATEGORY_EVENT:
            output = 'Event'
        elif self.category == self.NOTIFICATION_CATEGORY_SUPEREVENT:
            output = 'Superevent'

        # Add label stuff
        if self.label_query or self.labels.exists():
            action = 'labeled with {labels}'
            if self.label_query:
                labels = '({0})'.format(self.label_query)
            else:
                labels = " & ".join([l.name for l in self.labels.all()])
                if self.labels.count() > 1:
                    labels = '({0})'.format(labels)
            action = action.format(labels=labels)
        else:
            if self.far_threshold or self.ns_candidate:
                action = 'created or updated'
            else:
                action = 'created'
        output += ' {action}'.format(action=action)

        # Add groups, pipelines, searches for event-type notifications
        if self.category == self.NOTIFICATION_CATEGORY_EVENT:
            output += ' & {groups} & {pipelines} & {searches}'
            if self.groups.exists():
                grps = " | ".join([g.name for g in self.groups.all()])
                if self.groups.count() > 1:
                    grps = '({0})'.format(grps)

gracedb/superevents/forms.py
import logging
import os

from django import forms

from superevents.models import Signoff

# Set up logger
logger = logging.getLogger(__name__)


class SignoffForm(forms.ModelForm):

    class Meta:
        model = Signoff
        fields = ['status', 'comment', 'signoff_type', 'instrument']

    def __init__(self, *args, **kwargs):
        super(SignoffForm, self).__init__(*args, **kwargs)
        # Hide some fields that we will populate either by default
        # when we instantiate the form or with the request data
        self.fields['signoff_type'].widget = forms.HiddenInput()
        self.fields['instrument'].widget = forms.HiddenInput()

gracedb/api/v2/events/views.py
from ...v1.events.views import *

gracedb/api/v2/main/views.py
from ...v1.main.views import *

gracedb/api/v2/superevents/views.py
from ...v1.superevents.views import *

gracedb/templates/superevents/file_list.html
{% extends "base.html" %}
{% block title %}Files for {{ object.superevent_id }}{% endblock %}
{% block heading %}Files for {{ object.superevent_id }}{% endblock %}
{% block pageid %}Superevent files{% endblock %}

{% block content %}
<p>{{ message }}</p>

<ul>
{% for filename in file_list %}
<li><a href="{% url "legacy_apiweb:default:superevents:superevent-file-detail" object.superevent_id filename %}">{{ filename }}</a></li>
{% endfor %}
</ul>

{% endblock %}

gracedb/templates/superevents/log_create_form.html
<h2>Create log message</h2>

<div style="padding-bottom: 20px">
<form enctype="multipart/form-data" action="{% url "superevents:create-log" superevent.superevent_id %}" method="POST">
    <table>
        {{ log_create_form.as_table }}
    </table>
    <input type="submit" value="Submit" />
</form>
</div>

gracedb/templates/superevents/preferred_event_info_table.html
{% load timeutil %}
{% load scientific %}
<table class="event">
    <tr>
        <th>UID</th>
        <th>Labels</th>
        <th>Group</th>
        <th>Pipeline</th>
        <th>Search</th>
        <th>Instruments</th>
        <th>
            <div id="basic_info_event_ts"></div>
            <div> Event Time </div>
        </th>
        <th>FAR (Hz)</th>
        <th>FAR (yr<sup>-1</sup>)</th>
        <th>Links</th>
        <th>
            <div id="basic_info_created_ts"></div>
            <div>Submitted</div>
        </th>
    </tr>
    <tr>
        <td><a href="{% url "view" preferred_event.graceid %}">{{ preferred_event.graceid }}</a></td>
        <td>
        {% for labelling in preferred_event_labelling %}
            <div onmouseover="tooltip.show(tooltiptext('{{labelling.label.name}}', '{{labelling.creator.username}}', '{{labelling.created|utc}}', '{{labelling.label.description}}'));" onmouseout="tooltip.hide();" style="color: {{labelling.label.defaultColor}};" class="label">
                {{ labelling.label.name }}
            </div>
        {% endfor %}
        </td>
        <td>{{ preferred_event.group.name }} </td>
        <td>{{ preferred_event.pipeline.name }} </td>
        <td>{{ preferred_event.search.name }} </td>
        <td>{{ preferred_event.instruments }}</td>
        <td>
            {% if preferred_event.gpstime %}
            {{ preferred_event.gpstime|multiTime:"gps" }}
            {% endif %}
        </td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far|scientific }}</td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far_hr }}</td>
        <td><a href="{{ preferred_event.weburl }}">Data</a></td>
        <td>{{ preferred_event.created|multiTime:"created" }}</td>
    </tr>
</table>

gracedb/templates/superevents/public_alerts.html
{% extends "base.html" %}
{% load sanitize_html %}
{% load logtags %}
{% load static %}


{% block csslink %}
{{ block.super }}
<link rel="stylesheet" href="{% static "css/public.css" %}" />
<meta name="viewport" content="width=device-width, initial-scale=1">
{% endblock %}

{% block heading %}{% endblock %}
{% block pageid %}public{% endblock %}

{% block jscript %}
<link rel="stylesheet" type="text/css" href="{% static "tablesaw/dist/tablesaw.css" %}" />
<script language="javascript" type="text/javascript" src="{% static "tablesaw/dist/tablesaw.js" %}"></script>
<script language="javascript" type="text/javascript" src="{% static "tablesaw/dist/tablesaw-init.js" %}"></script>
{% endblock %}

{% block content %}
<br />
<h1>LIGO/Virgo Public Alerts</h1>

<h3>Detection candidates: {{ candidates }}</h3>
<br /><br />

{% if candidates > 0 %}
<div class="tablesaw-overflow">
<table class="tablesaw" data-tablesaw-sortable data-tablesaw-sortable-switch data-tablesaw-mode="columntoggle" data-tablesaw-minimap>
  <thead><tr>
      <th scope="col" data-tablesaw-sortable-col data-tablesaw-priority="persist">Event ID</th>
      <th scope="col" data-tablesaw-sortable-col data-tablesaw-priority="1">Possible Source (Probability)</th>
      <th scope="col" data-tablesaw-sortable-col data-tablesaw-sortable-string data-tablesaw-priority="2">UTC</th>
      <th scope="col" data-tablesaw-col data-tablesaw-priority="3">GCN</th>
      <th scope="col" data-tablesaw-col data-tablesaw-priority="4">Location</th>
      <th scope="col" data-tablesaw-sortable-col data-tablesaw-priority="5">FAR</th>
      <th scope="col" data-tablesaw-col data-tablesaw-priority="6">Comments</th>
      <th scope="col" data-tablesaw-sortable-col data-tablesaw-priority="0">GPS</th>

      {% if user_is_internal %}
      <th scope="col" data-tablesaw-col data-tablesaw-priority="6">&Omega; Scan</th>
      <th scope="col" data-tablesaw-col data-tablesaw-priority="6">PE</th>
      {% endif %}

    </tr>
  </thead>
  <tbody>


{% for event in object_list %}
<tr{% if event.retract %} style="background-color: #EDD;" {% endif %}>

  <td style="min-width: 100px;">
    <a href="{% url "superevents:view" event.superevent_id %}">{{ event.default_superevent_id }}</a>
  </td>
  <td style="min-width: 100px;">{{ event.sourcetypes }}</td>
  <td style="min-width: 140px;">
    <span style="font-size: 0px;">{{ event.t_0|floatformat:2 }}</span>{{ event.t_0_date }}<br/>
    {{ event.t0_utc }} UTC
  </td>
  <td style="min-width: 110px;">
    <a href={{ event.gcnurl }}>GCN Circulars</a><br/>
    <a href={{ event.noticeurl }}>Notices</a> | <a href="{% url "legacy_apiweb:default:superevents:superevent-voevent-list" event.default_superevent_id %}">VOE</a>
  </td>
  <td>
    {% if event.skymap_image %}
    <a href="{{ event.skymap_image }}">
      <img src="{{ event.skymap_image }}" width="120px" />
    </a>
    {% else %}
    No public skymap image found.
    {% endif %}
  </td>
  <td style="min-width: 120px;">
    <!-- Hidden float FAR value for table sorting -->
    <span style="font-size: 0px;">{{ event.far_hz|floatformat:20 }}</span>{{ event.far_hr }}
  </td>
  <td style="min-width: 80px;">{{ event.comments|safe }} </td>
  <td>{{ event.t_0|floatformat:2 }} </td>

  {% if user_is_internal %}
  <!-- Add Omega scans and PE results for LVC users -->
  <td style="min-width: 70px;">
    <a href="https://ldas-jobs.ligo-la.caltech.edu/~detchar/dqr/events/{{ event.superevent_id }}/L1deepomegascan/">&Omega; L1</a><br/>
    <a href="https://ldas-jobs.ligo-wa.caltech.edu/~detchar/dqr/events/{{ event.superevent_id }}/H1deepomegascan/">&Omega; H1</a>
  </td>
  <td>{{ event.pe|safe }}</td>
  {% endif %}

</tr>
{% endfor %}
</tbody></table>
</div>

<hr />
<ul style="list-style-type: square;">
  <li>Retractions are marked in red.</li>
  <li>More details about public alerts are provided in the <a href="https://emfollow.docs.ligo.org/userguide/">LIGO/Virgo Alerts User Guide</a>.</li>
</ul>
{% else %}
<h2>No candidates at present.</h2>
{% endif %}
<br /><br /><br />

{% endblock %}

gracedb/templates/superevents/superevent_info_table.html
{% load timeutil %}
<table class="superevent">
    <tr>
        <th>Superevent ID</th>
        {% if superevent.is_gw %}
        <th>GW ID</th>
        {% endif %}
        <th>Category</th>
        <th>Labels</th>
        <th>Preferred event</th>
        <th>GW events</th>
        <th>External events</th>
        <th>t_start</th>
        <th>t_0</th>
        <th>t_end</th>
        <th>
            <div id="superevent_created_ts"></div>
            <div>Submission time</div>
        </th>
        <th>Links</th>
    </tr>
    <tr>
        <td>{{ superevent.default_superevent_id }}</td>
        {% if superevent.is_gw %}
        <td>{{ superevent.gw_id }}</td>
        {% endif %}
        <td>{{ superevent.get_category_display }}</td>
        <td>
        {% for labelling in superevent.labelling_set.all %}
            <div onmouseover="tooltip.show(tooltiptext('{{labelling.label.name}}', '{{labelling.creator.username}}', '{{labelling.created|utc}}', '{{labelling.label.description}}'));" onmouseout="tooltip.hide();" style="color: {{labelling.label.defaultColor}};" class="label">
                {{ labelling.label.name }}
            </div>
       {% endfor %}
        </td>
        <td><a href="{% url "view" preferred_event.graceid %}">{{ preferred_event.graceid }}</a></td>
        <td>
            <div>
            {% for graceid in internal_events %}
            <a href="{% url "view" graceid %}">{{ graceid }}</a>
            {% endfor %}
            </div>
        </td>
        <td>
            <div>
            {% for graceid in external_events %}
            <a href="{% url "view" graceid %}">{{ graceid }}</a>
            {% endfor %}
            </div>
        </td>
        <td>{{ superevent.t_start }}</td>
        <td>{{ superevent.t_0 }}</td>
        <td>{{ superevent.t_end }}</td>
        <td>{{ superevent.created|multiTime:"superevent_created" }}</td>
        <td><a href="{% url "superevents:file-list" superevent.superevent_id %}">Data</a></td>
    </tr>
</table>

gracedb/templates/superevents/superevent_info_table_public.html
{% load timeutil %}
{% load scientific %}
<table class="superevent">
    <tr>
        <th>Superevent ID</th>
        {% if superevent.is_gw %}
        <th>GW ID</th>
        {% endif %}
        <th>Category</th>
        <th>Labels</th>
        <th>FAR (Hz)</th>
        <th>FAR (yr<sup>-1</sup>)</th>
        <th>t_start</th>
        <th>t_0</th>
        <th>t_end</th>
        <th>
            <div id="superevent_created_ts"></div>
            <div>Submission time</div>
        </th>
        <th>Links</th>
    </tr>
    <tr>
        <td>{{ superevent.default_superevent_id }}</td>
        {% if superevent.is_gw %}
        <td>{{ superevent.gw_id }}</td>
        {% endif %}
        <td>{{ superevent.get_category_display }}</td>
        <td>
        {% for labelling in superevent.labelling_set.all %}
            <div onmouseover="tooltip.show(tooltiptext('{{labelling.label.name}}', '{{labelling.creator.username}}', '{{labelling.created|utc}}', '{{labelling.label.description}}'));" onmouseout="tooltip.hide();" style="color: {{labelling.label.defaultColor}};" class="label">
                {{ labelling.label.name }}
            </div>
       {% endfor %}
        </td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far|scientific }}</td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far_hr }}</td>
        <td>{{ superevent.t_start }}</td>
        <td>{{ superevent.t_0 }}</td>
        <td>{{ superevent.t_end }}</td>
        <td>{{ superevent.created|multiTime:"superevent_created" }}</td>
        <td><a href="{% url "superevents:file-list" superevent.superevent_id %}">Data</a></td>
    </tr>
</table>